﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace SleepTimer
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void radioButton1_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            sleepUnit.SelectedIndex = 0;
        }

        private void runPsShutdownCommand(string args)
        {
            ProcessStartInfo startInfo = new ProcessStartInfo("C:\\Users\\sylecn\\Downloads\\apps\\pstools\\psshutdown.exe");
            startInfo.Arguments = args;
            //startInfo.Verb = "runas";
            startInfo.UseShellExecute = false;
            startInfo.RedirectStandardOutput = true;
            startInfo.RedirectStandardError = true;
            Process cmd = Process.Start(startInfo);
            cmd.WaitForExit();
            MessageBox.Show(cmd.StandardError.ReadToEnd() + "====\n" + cmd.StandardOutput.ReadToEnd());
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (actionRadio.Checked)
            {
                // set sleep timer
                string selectUnit = sleepUnit.SelectedItem.ToString();
                int waitSeconds = 0;
                if (selectUnit == "minutes")
                {
                    waitSeconds = (int)sleepNumber.Value * 60;
                }
                else if (selectUnit == "hours")
                {
                    waitSeconds = (int)sleepNumber.Value * 3600;
                }
                else
                {
                    MessageBox.Show("Please select unit");
                    return;
                }
                Console.Write("will sleep after {0} {1}\n", (int)sleepNumber.Value, selectUnit);
                runPsShutdownCommand("-c -d -t " + waitSeconds.ToString());
            }
            else
            {
                // cancel pending sleep
                runPsShutdownCommand("-a");
            }

            Application.Exit();
        }
    }
}
